Index: trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/basexecut.cc	(revision 384)
+++ trunk/SophyaPI/PIext/basexecut.cc	(revision 388)
@@ -576,4 +576,7 @@
 }
 
+// Fonction pour enregistrer le Help des Widgets et Windows de piapp 
+static void RegisterPIGraphicsHelp(PIACmd* piac);
+
 /* --Methode-- */
 void PIABaseExecutor::RegisterCommands()
@@ -597,7 +600,9 @@
 kw = "zone";
 usage = "To Divide the Graphic window \n  Usage: zone [nx=1 ny=1]";
+usage += "\n  Related commands: newwin";  
 mpiac->RegisterCommand(kw, usage, this, "Graphics");
 kw = "newwin";
 usage = "To Create a New Graphic window, with zones \n  Usage: newwin nx ny";
+usage += "\n  Related commands: zone";  
 mpiac->RegisterCommand(kw, usage, this, "Graphics");
 kw = "stacknext";
@@ -642,4 +647,6 @@
 usage += "\n  Related commands: gratt";  
 mpiac->RegisterCommand(kw, usage, this, "Graphics");
+
+RegisterPIGraphicsHelp(mpiac);
 
 kw = "openfits";
@@ -954,2 +961,83 @@
 }
 
+/* Nouvelle-Fonction */
+void RegisterPIGraphicsHelp(PIACmd* piac)
+{
+string kw,grp,usage;
+
+grp = "Graphics";
+
+kw = "PIImage";
+usage = "Manages the display of a 2-D array (P2DArrayAdapter) as an image \n";
+usage += "and controls a zoom widget, as well as a global image view widget \n";
+usage += ">>>> Mouse controls : \n";
+usage += "o Button-1: Display current coordinates and pixel value\n";
+usage += "  Position the cursor an refresh the zoom widget\n";
+usage += "o Button-2: Defines an image zone and positions the cursor \n";
+usage += "o Button-3: Moves the viewed portion of the array inside the window \n";
+usage += ">>>> Keyboard controls : \n";
+usage += "o <Alt>R : Refresh display \n";
+usage += "o <Alt>O : Shows the PIImageTools (image display parameter controls) \n";
+usage += "o <Alt>G : Show the PIDrawerTools (Graphic attributes of overlayed graphics (Drawers)) \n";
+usage += "o <Alt>V : Copy/Paste / Text paste at the current cursor position \n";
+usage += "o <Alt>C : Copy/Paste / Copies the selected regions content as text in the copy/paste buffer \n";
+usage += "o <Alt>X : Show/Hide the Cut Window \n";
+usage += "o <Alt>Z : Removes signs overlayed on image (Drawer 0) \n";
+usage += "o Cursor keys : Moves the image cursor \n";
+piac->RegisterHelp(kw, usage, grp);
+
+kw = "PIScDrawWdg";
+usage = "Manages display of 2-D drawers with interactive zoom \n";
+usage += ">>>> Mouse controls : \n";
+usage += "o Button-1: Display current coordinates \n";
+usage += "o Button-2: Defines a rectangle for zoom \n";
+usage += "o Button-3: Defines a rectangle for Text-Info (<Alt>I) \n";
+usage += ">>>> Keyboard controls : \n";
+usage += "o <Alt>R : Refresh display \n";
+usage += "o <Alt>O : Displays a specific control window (default: PIDrawerTools) \n";
+usage += "           Specific controls for 2-D histograms \n";
+usage += "o <Alt>G : Show the PIDrawerTools (Graphic attributes of displayed Drawers) \n";
+usage += "           Drawer 0 manages the axes, as well as the added text \n";
+usage += "o <Alt>V : Copy/Paste / Text paste at the current position \n";
+usage += "o <Alt>Z : Removes added signs (text) to Drawer 0 \n";
+usage += "o <Alt>I : Shows (or updates) a text info window on the selected rectangle\n";
+usage += "o <Alt>M : Activate/Deactivate a measurement cursor on Button-1";
+usage += "o Cursor keys : Moves the image cursor \n";
+piac->RegisterHelp(kw, usage, grp);
+
+kw = "PIDraw3DWdg";
+usage = "Manages display of 3-D objects (drawers)  \n";
+usage += ">>>> Mouse controls : \n";
+usage += "o Button-2: Rotates the observer (camera) around object \n";
+usage += "o Shift-Button-2: Rotates object with camera fixed \n";
+usage += "  The object rotation mode can be assigned to Button-2 with <Alt>S \n";
+usage += "o Button-3: Zoom control (Camera distance And/Or view angle) \n";
+usage += ">>>> Keyboard controls : \n";
+usage += "o <Alt>R : Resets the 3-D view and refreshes the display \n";
+usage += "o <Alt>G : Show the PIDrawerTools (Graphic attributes of displayed Drawers) \n";
+usage += "o <Alt>O : = <Alt>G \n";
+usage += "o <Alt>V : Copy/Paste / Text paste at the current position (Drawer 0)\n";
+usage += "o <Alt>Z : Removes added signs (text) to Drawer 0 \n";
+usage += "o <Alt>A : Activate/Deactivate axes drawing \n";
+usage += "o <Alt>S : Activate/Deactivate object rotation mode on Button-2 \n";
+piac->RegisterHelp(kw, usage, grp);
+
+kw = "Windows";
+usage = "Objects can be displayed in different windows, or overlayed on the \n";
+usage += "previous display. The graphics attributes next,win,stack,same control \n";
+usage += "the display window. \n";
+usage += "o GraphicWindow : This is the default mode (gr_att=next)\n";
+usage += "  Graphic windows can be divided int zones. Object is displayed \n";
+usage += "  in the next available position, removing a previously displayed \n";
+usage += "  widget if necessary \n";
+usage += "o Window : An object is displayed in its own window (gr_att= win) \n";
+usage += "o StackWindow : multpile widgets can be stacked in a StackWindow (gr_att= stack) \n";
+usage += "  A single widget is displayed a any time. Different widgets in a StackWindow \n";
+usage += "  can be displayed using the stacknext command, as well as the StackTools item \n";
+usage += "  in the Tools menu (from Menubar). An automatic cyclic display mode can also \n";
+usage += "  be activated using the StackTools menu (Blink) \n";
+usage += "o Most objects can be also be displayed, overlayed on the last displayed widget (gr_att= same) \n";
+usage += "\n  Related commands: newwin zone stacknext gratt";  
+piac->RegisterHelp(kw, usage, grp);
+ 
+}