Index: /trunk/Poubelle/archTOI.old/Makefile
===================================================================
--- /trunk/Poubelle/archTOI.old/Makefile	(revision 396)
+++ /trunk/Poubelle/archTOI.old/Makefile	(revision 397)
@@ -1,10 +1,11 @@
 CXX=cxx
 CFITSIODIR=../cfitsio
-CPPFLAGS=-O -I$(CFITSIODIR)
-#CPPFLAGS=-g -I$(CFITSIODIR)
+#CPPFLAGS=-O -I$(CFITSIODIR)
+CPPFLAGS=-g -I$(CFITSIODIR)
 LDLIBS=-L$(CFITSIODIR) -lcfitsio
 archtoi: archtoimain.o archtoi.o archeopsfile.o decompress.o toiiter.o toisvr.o archeops.o \
          ssthandler.o toiinterpolator.o gpsparser.o asigps.o \
-         auxinterpgps.o tsid.o
+         auxinterpgps.o tsid.o archparam.o dyffttools.o fft_mayer.o \
+         formepulse.o pisteetoile.o sstetoile.o transfelec.o
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm 
 archdump: archtoidump.o archeopsfile.o decompress.o archeops.o ssthandler.o
@@ -28,5 +29,4 @@
  tsid.h
 gpsparser.o: gpsparser.cc gpsparser.h archeops.h archeops_28.h
-ssthandler.o: ssthandler.cc ssthandler.h archeops.h archeops_28.h
 test.o: test.cc archeopsfile.h archeops.h archeops_28.h ssthandler.h \
  gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
@@ -41,2 +41,15 @@
 archeops.o: archeops.c archeops_28.c archeops.h archeops_28.h
 decompress.o: decompress.c archeops.h archeops_28.h compress.h
+transfelec.o: transfelec.cc transfelec.h
+sstetoile.o: sstetoile.cc sstetoile.h
+ssthandler.o: ssthandler.cc ssthandler.h archeops.h archeops_28.h \
+ sstetoile.h pisteetoile.h transfelec.h formepulse.h
+formepulse.o: formepulse.cc mayer_fft.h dyffttools.h transfelec.h \
+ formepulse.h ssthardware.h
+pisteetoile.o: pisteetoile.cc \
+ /home/usr203/mnt/gnu/OSF1/lib/gcc-lib/alphaev5-dec-osf4.0d/2.8.1/include/math.h \
+ /home/usr203/mnt/gnu/include/g++/iostream.h archparam.h pisteetoile.h \
+ sstetoile.h transfelec.h formepulse.h
+dyffttools.o: dyffttools.cc dyffttools.h
+fft_mayer.o: fft_mayer.cc mayer_fft.h trigtbl.h
+archparam.o: archparam.cc archparam.h
Index: /trunk/Poubelle/archTOI.old/archeopsfile.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 396)
+++ /trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 397)
@@ -558,8 +558,10 @@
        memcpy(&blockSet->curBlock,&blk2,sizeof(blk2));
        curKind = block_sst;
+       //       cout << "process " << numero_block(&blockSet->curBlock) << "\n";
        blockSet->sstHandler.ProcessBlock((block_type_sst*)&blockSet->curBlock);
        break;
      }
      case block_sst : {
+       //       cout << "process " << numero_block(&blockSet->curBlock) << "\n";
        blockSet->sstHandler.ProcessBlock((block_type_sst*)&blockSet->curBlock);
      }
Index: /trunk/Poubelle/archTOI.old/pisteetoile.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/pisteetoile.cc	(revision 396)
+++ /trunk/Poubelle/archTOI.old/pisteetoile.cc	(revision 397)
@@ -116,4 +116,5 @@
 //	if(!isAlive()) return;
 	indexDebutPiste=InDebutPiste;
+	//	cout << "fill " << indexDebutPiste << "\n";
 	int* PhDiod=PhDiodArray;
 	int* pDataC=pData;
@@ -130,4 +131,5 @@
 	for(int i=0; i<nbdata; i++, PPhDiod++,pDataC++) *PPhDiod=(*pDataC);
 	indexDebutPiste+=nbdata; 
+	//	cout << "push " << nbdata << " " << indexDebutPiste << "\n";
 	return;
 }
@@ -153,4 +155,5 @@
 		if(testEtoile) {
 		// On emballe une etoile.
+		  //		  cout << "star " << setprecision(10) << TIndex << "\n";
 			LastEtoile.FitForme=SuccesAFine;
 			LastEtoile.X2Calc=X2Min;
@@ -206,8 +209,8 @@
 	gachette=false;
 	short iSeuil=0;
-	double* pPiste =PhDiodPiste+Prepulselong;
+	double* pPiste =PhDiodPiste+Prepulselong-1;
 	
 // On demande deux échantillons à 2 Vrms
-	for (int i=0; i<(PhDiodTabLong-Prepulselong-1); i++, pPiste++) {
+	for (int i=-1; i<(PhDiodTabLong-Prepulselong-1); i++, pPiste++) {
 		if (fabs(*pPiste)>(SeuilGachette*Vrms)) 
 			if (fabs(*(pPiste+1))>SeuilGachette*Vrms) {
@@ -272,5 +275,5 @@
 //	On stocke les resultats
 		TIndex=indexDebutPiste+Prepulselong+MaxIndex+tmaxfit;
-		
+		//		cout << "tindex " << TIndex << " " <<indexDebutPiste<<" " <<Prepulselong << " " <<MaxIndex << " " << tmaxfit << "\n";
 		X2Min=0.;
 		SuccesAFine=false;
Index: /trunk/Poubelle/archTOI.old/ssthandler.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/ssthandler.cc	(revision 396)
+++ /trunk/Poubelle/archTOI.old/ssthandler.cc	(revision 397)
@@ -184,4 +184,5 @@
   	int jd0 = diodeHistLength-NbSampleBlock;
 
+	//	cout << "find " << NoFirstSpInBlock << "\n";
 	bool FlagLBlockPerdu=false;
 	int ThisBlockNumb=numero_block(blk);