Index: trunk/Poubelle/archTOI.old/toiiter.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiiter.cc	(revision 406)
+++ trunk/Poubelle/archTOI.old/toiiter.cc	(revision 407)
@@ -1,4 +1,12 @@
 // toiiter.cc
 // Eric Aubourg         CEA/DAPNIA/SPP   juillet 1999
+
+#ifndef nb_max_bolo
+#define _archeops		//  Acquisition Archeops (avec transputer) 
+#define programme
+extern "C" {
+#include "archeops.h"
+}
+#endif
 
 
@@ -204,41 +212,57 @@
       switch ((*i).kind) {
       case boloTens:
+      case boloTens2:
       case boloRaw:
-	trigMask |= block_bolo_mask;
-	break;
+      case boloRes:
+      case boloTemp:
+      case boloRawCN:
+      case boloTens2T:
+        trigMask |= block_bolo_mask;
+        break;
+      case boloGainAmpli:
+        trigMask |= block_reglage_mask;
+        break;
       case gpsTime:
       case longitude:
       case latitude:
       case altitude:
-	trigMask |= block_gps_mask;
-	break;
+        trigMask |= block_gps_mask;
+        break;
       case azimut:
-	file->needSSTProcessMask(SSTHandler::findPeriod);
-	trigMask |= block_sst_mask;
-	break;
+        file->needSSTProcessMask(SSTHandler::findPeriod);
+        trigMask |= block_sst_mask;
+        break;
       case sstStarCnt:
       case sstStarZ:
       case sstStarF:
       case sstStarT:
-	file->needSSTProcessMask(SSTHandler::findStars);
-	trigMask |= block_sst_mask;
-	break;
+        file->needSSTProcessMask(SSTHandler::findStars);
+        trigMask |= block_sst_mask;
+        break;
       case sstDiode:
-	file->needSSTProcessMask(SSTHandler::permDiode);
-	trigMask |= block_sst_mask;
-	break;
+      case sstDiodeCN:
+        file->needSSTProcessMask(SSTHandler::permDiode);
+        trigMask |= block_sst_mask;
+        break;
       case sstChannel:
-	trigMask |= block_sst_mask;
-	break;
+      case sstChannelCN:
+        trigMask |= block_sst_mask;
+        break;
       case gyroRaw:
-	trigMask |= block_gyro_mask;
-	break;
+      case gyroTens:
+        trigMask |= block_gyro_mask;
+        break;
+      case gyroSpeed:
+        trigMask |= block_gyro_mask; // $CHECK$ + info to calibrate gyros
+        break;
       case alphaAxis:
       case deltaAxis:
+      case alphaSst:
+      case deltaSst:
       case alphaBolo:
       case deltaBolo:
-	file->needSSTProcessMask(SSTHandler::findAxis);
-	trigMask |= block_sst_mask;
-	break;
+        file->needSSTProcessMask(SSTHandler::findAxis);
+        trigMask |= block_sst_mask;
+        break;
       }
     }
@@ -407,10 +431,18 @@
      return true;
    case boloTens:
+   case boloTens2:
+   case boloTens2T:
+   case boloRes:
+   case boloRawCN:
      if (imes==0 && file->llastBolo()==NULL) return false;
      return file->lastBolo() != NULL;
    case boloRaw:
      return file->lastBolo() != NULL;
+   case boloGainAmpli:
+     return file->lastReglage() != NULL;
    case sstDiode:
    case sstChannel:
+   case sstDiodeCN:
+   case sstChannelCN:
      return file->lastSST() != NULL;
    case sstStarCnt:
@@ -423,4 +455,6 @@
    }
    case gyroRaw:
+   case gyroTens:
+   case gyroSpeed:
      return (file->lastGyro() != NULL);
    case gpsTime:
@@ -450,4 +484,5 @@
 }
 
+
 double TOIIter::getValue(int column) {
   if (!initDone) Init();
@@ -484,4 +519,6 @@
    case boloRaw:
      return file->getRawBolo(index, imes);
+   case boloGainAmpli:
+     return file->getGainAmpli(index);
    case sstDiode:
      return file->getSSTSignal(index, imes);
@@ -497,5 +534,9 @@
      return file->getSSTStarT(index, imes);
    case gyroRaw:
-     return file->getGyro(index, imes);
+     return file->getGyroRaw(index, imes);
+   case gyroTens:
+     return file->getGyroTens(index, imes);
+   case gyroSpeed:
+     return file->getGyroSpeed(index, imes);
    case gpsTime:
      return file->getGPSUTC();
@@ -540,4 +581,6 @@
      case boloRaw:
        return file->blockNum() == file->getBoloBlockNum();
+     case boloGainAmpli:
+       return file->blockNum() == file->getReglageBlockNum() && imes==0;
      case sstChannel:
      case sstDiode:
@@ -548,4 +591,6 @@
        return file->blockNum() == file->getSSTBlockNum();
      case gyroRaw:
+     case gyroTens:
+     case gyroSpeed:
        return file->blockNum() == file->getGyroBlockNum();
      case gpsTime: