Index: /trunk/Poubelle/archTOI.old/archeopsfile.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 409)
+++ /trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 410)
@@ -777,4 +777,9 @@
 }
 
+int ArcheopsFile::getDilutionBlockNum() {
+  if (!lastDilution()) return -1;
+  return numero_block(lastDilution());
+}
+
 
 int ArcheopsFile::getSSTBlockNum() {
@@ -938,4 +943,27 @@
 }
 
+double ArcheopsFile::getBoloRes(int ibolo, int imesure) {
+  double i = getDACI(ibolo); // microAmps
+  double v = getMuVBolo2T(ibolo, imesure); // microVolts
+  double r = v/i; // Ohms
+  return r;
+}
+
+// Dilution
+
+int4 ArcheopsFile::getADCDil(int iADC) {
+  block_type_dilution* blk = lastDilution();
+  if (!blk) return 0;
+  if (iADC < 0 || iADC > 47) return 0;
+  return blk->ADC_dil[iADC];
+}
+
+int4 ArcheopsFile::getSwitchDil() {
+  block_type_dilution* blk = lastDilution();
+  if (!blk) return 0;
+  return blk->switch_dil;
+}
+
+
 // SST, gyros...
 
@@ -951,4 +979,14 @@
   return blockSet->sstHandler.getRawSignal(imesure, idiode);
 }
+
+long ArcheopsFile::getSSTSignalCN(int idiode, int imesure) {
+
+}
+
+long ArcheopsFile::getSSTRawSignalCN(int idiode, int imesure) {
+
+}
+
+
 
 double ArcheopsFile::getSSTStarZ(int istar, int imesure) {
Index: /trunk/Poubelle/archTOI.old/archeopsfile.h
===================================================================
--- /trunk/Poubelle/archTOI.old/archeopsfile.h	(revision 409)
+++ /trunk/Poubelle/archTOI.old/archeopsfile.h	(revision 410)
@@ -134,6 +134,12 @@
   double getGainAmpli(int ibolo);
   double getDACV(int ibolo); // offset en microvolt
-  double getDACI(int ibolo); // courant en picoAmps
+  double getDACI(int ibolo); // courant en microAmps
   double getMuVBolo2T(int ibolo, int imesure); // avec soustraction dacV
+  double getBoloRes(int ibolo, int imesure); // Ohms
+  
+  // Dilution
+  int getDilutionBlockNum();
+  int4 getADCDil(int iADC);
+  int4 getSwitchDil();
   
   // SST, gyros, etc
@@ -142,4 +148,6 @@
   long getSSTRawSignal(int iDiode, int imesure);
   long getSSTSignal(int iDiode, int imesure);
+  long getSSTRawSignalCN(int iDiode, int imesure);
+  long getSSTSignalCN(int iDiode, int imesure);
   double getSSTStarZ(int iStar, int imesure);
   double getSSTStarF(int iStar, int imesure);
Index: /trunk/Poubelle/archTOI.old/toiiter.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/toiiter.cc	(revision 409)
+++ /trunk/Poubelle/archTOI.old/toiiter.cc	(revision 410)
@@ -214,10 +214,15 @@
       case boloTens2:
       case boloRaw:
+      case boloRawCN:
+        trigMask |= block_bolo_mask;
+        break;
+      case boloTens2T:
       case boloRes:
       case boloTemp:
-      case boloRawCN:
-      case boloTens2T:
-        trigMask |= block_bolo_mask;
-        break;
+         trigMask |= block_bolo_mask | block_reglage_mask;
+        break;
+     case dilDAC:
+      case dilSwitch:
+        trigMask |= block_dilution_mask;
       case boloGainAmpli:
       case boloDACV:
@@ -445,4 +450,7 @@
    case boloDACI:
      return file->lastReglage() != NULL;
+   case dilDAC:
+   case dilSwitch:
+     return file->lastDilution() != NULL;
    case sstDiode:
    case sstChannel:
@@ -531,4 +539,12 @@
    case boloDACI:
      return file->getDACI(index);
+   case boloTens2T:
+     return file->getMuVBolo2T(index, imes);
+   case boloRes:
+     return file->getBoloRes(index, imes);
+   case dilDAC:
+     return file->getADCDil(index);
+   case dilSwitch:
+     return file->getSwitchDil();
    case sstDiode:
      return file->getSSTSignal(index, imes);
@@ -589,4 +605,6 @@
      case boloTens:
      case boloTens2:
+     case boloTens2T:
+     case boloRes:
        return file->blockNum() == file->getBoloBlockNum();
      case boloRaw:
@@ -597,4 +615,7 @@
      case boloDACV:
        return file->blockNum() == file->getReglageBlockNum() && imes==0;
+     case dilDAC:
+     case dilSwitch:
+       return file->blockNum() == file->getDilutionBlockNum() && imes==0;
      case sstChannel:
      case sstDiode:
Index: /trunk/Poubelle/archTOI.old/toiiter.h
===================================================================
--- /trunk/Poubelle/archTOI.old/toiiter.h	(revision 409)
+++ /trunk/Poubelle/archTOI.old/toiiter.h	(revision 410)
@@ -21,11 +21,13 @@
   boloTens2,     // tension en microVolts, avec soustraction offset filtre
   boloRaw,       // tension brute en microVolts, non filtree indexe par bolometre, sans chgt signe
-  boloRes,       // Resistance, ohms
   boloTemp,      // Kelvins, need R(T) -> N/A
   boloGainAmpli, // gain de l'ampli du bolo
   boloDACV,      // tension de reference du DAC (microVolts)
-  boloDACI,      // courant (picoAmps)
+  boloDACI,      // courant (microAmps)
   boloRawCN,     // compression noise on bolo raw
   boloTens2T,    // total, microVolts, avec consigne DAC
+  boloRes,       // Resistance, ohms
+  dilDAC,        // dilution DAC, index = 0-47
+  dilSwitch,     // dilution, mot de 32 bits
   sstDiode,      // signal brut SST, indice = diode, 0-45
   sstChannel,    // signal brut SST, indice = canal, 0-47
Index: /trunk/Poubelle/archTOI.old/toisvr.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/toisvr.cc	(revision 409)
+++ /trunk/Poubelle/archTOI.old/toisvr.cc	(revision 410)
@@ -109,4 +109,6 @@
     else tsttoi(boloTens2T)
     else tsttoi(boloRawCN)
+    else tsttoi(dilDAC)
+    else tsttoi(dilSwitch)
     else tsttoi(sstDiode)
     else tsttoi(sstChannel)