Index: /trunk/Poubelle/archTOI.old/archeopsfile.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 415)
+++ /trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 416)
@@ -886,4 +886,23 @@
 }
 
+long ArcheopsFile::getRawBoloCN(int ibolo, int imesure) {    
+  // Si pas bloc comprime -> 0
+  if (lastBoloComp() == NULL) return 0;
+  if (numero_block(lastBoloComp()) != numero_block(lastBolo())) return 0;
+  block_type_reglage* reglage = lastReglage();
+  if (!reglage) return 0;
+
+  int nb_coups= reglage->reglage.horloge.nb_mesures/2 - reglage->reglage.horloge.temp_mort;
+  unsigned int4* data = lastBoloComp()->data_bolo[ibolo];
+  // Les deux premieres valeurs sont codees directement...
+  if (imesure<2) return 0;
+  int iExp = (imesure-2)/4 + 1;
+  int expo = data[iExp] & 0xf;
+  int noise = 1 << expo;
+  return (noise << 1)/nb_coups;
+}
+
+
+
 def_gains 
 
@@ -899,4 +918,14 @@
   //return ((1e5*y)/(65536.*gain_ampli(reglage->reglage.bolo[ibolo])));
 }
+
+double ArcheopsFile::getMuVBoloCN(int ibolo, int imesure) { // microvolts, sur valeur unique 
+  double y = getRawBoloCN(ibolo, imesure);
+  block_type_reglage* reglage = lastReglage();
+  block_type_param*   param = lastParam();
+  if (!reglage) return 0;
+  if (!param) return 0;
+  return bol_micro_volt(y,(double)param->param.bolo[ibolo].bolo_gain*gain_ampli(reglage->reglage.bolo[ibolo]));
+}
+
 
 double ArcheopsFile::getMuVBolo2(int ibolo, int imesure) { // microvolts, filtre 
@@ -1001,4 +1030,5 @@
   
   // Attention, on ne transmet pas les canaux 0 et 4....
+  if (ichannel == 0 || ichannel == 4) return 0;
   int i = ichannel - 1;
   if (i >= 4) i--;
Index: /trunk/Poubelle/archTOI.old/archeopsfile.h
===================================================================
--- /trunk/Poubelle/archTOI.old/archeopsfile.h	(revision 415)
+++ /trunk/Poubelle/archTOI.old/archeopsfile.h	(revision 416)
@@ -131,4 +131,6 @@
   int getBoloCompBlockNum();
   long getRawBolo(int ibolo, int imesure);   // donnee brute, avec seulement soustraction offset
+  long getRawBoloCN(int ibolo, int imesure);  // bruit de compression, sur donnee brute
+  double getMuVBoloCN(int ibolo, int imesure);  // bruit de compression, en microVolts
   double getMuVBolo(int ibolo, int imesure); // microvolts, filtre avec filtre carre
   double getMuVBolo2(int ibolo, int imesure); // microvolts, filtre +sioux
Index: /trunk/Poubelle/archTOI.old/archtoi.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/archtoi.cc	(revision 415)
+++ /trunk/Poubelle/archTOI.old/archtoi.cc	(revision 416)
@@ -12,4 +12,5 @@
 #include "archtoi.h"
 #include "archparam.h"
+#include "archvers.h"
 
 using namespace std; 
Index: /trunk/Poubelle/archTOI.old/archtoi.h
===================================================================
--- /trunk/Poubelle/archTOI.old/archtoi.h	(revision 415)
+++ /trunk/Poubelle/archTOI.old/archtoi.h	(revision 416)
@@ -67,6 +67,3 @@
 };
 
-#define ARCHTOI_VERS "1.1"
-#define ARCHTOI_TAG  "notag"
-
 #endif
Index: /trunk/Poubelle/archTOI.old/archvers.h
===================================================================
--- /trunk/Poubelle/archTOI.old/archvers.h	(revision 416)
+++ /trunk/Poubelle/archTOI.old/archvers.h	(revision 416)
@@ -0,0 +1,7 @@
+#ifndef ARCHVERS_H
+#define ARCHVERS_H
+
+#define ARCHTOI_VERS "1.1"
+#define ARCHTOI_TAG  "notag"
+
+#endif
Index: /trunk/Poubelle/archTOI.old/auxinterpgps.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/auxinterpgps.cc	(revision 415)
+++ /trunk/Poubelle/archTOI.old/auxinterpgps.cc	(revision 416)
@@ -4,5 +4,5 @@
 #include "auxinterpgps.h"
 #include "fitsio.h"
-#include "archtoi.h"
+#include "archvers.h"
 
 AuxInterpGPS::AuxInterpGPS() {
Index: /trunk/Poubelle/archTOI.old/ssthandler.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/ssthandler.cc	(revision 415)
+++ /trunk/Poubelle/archTOI.old/ssthandler.cc	(revision 416)
@@ -15,6 +15,8 @@
 #include "pisteetoile.h"
 
+#ifdef SST_DUMPLOG
 ofstream SSTHandler::sstchass("SSTChassLogFile");
 bool     SSTHandler::sstchassinit=false;
+#endif
 
 // diodpermut[i] = channel de la diode i
@@ -255,5 +257,5 @@
 		LastBlockStarVec.push_back((*StarHistReIter).second);
 	
-//#ifdef SST_DEBUG
+#ifdef SST_DUMPLOG
 	if(NbStarInBlock>0) {
 			
@@ -265,5 +267,5 @@
 	}
 		
-//#endif
+#endif
 
 	return NbStarInBlock;
@@ -274,8 +276,10 @@
 	for(int i=0; i<NbPhotDiodBarette; i++) PisteBar[i]=new PisteEtoile(i);
 	StarHistoryMap.clear();
+#ifdef SST_DUMPLOG
 	if (!sstchassinit) {
 	  sstchass<<LastStar.printHeader()<<endl;
 	  sstchassinit = true;
 	}
+#endif
 	
 #ifdef SST_DEBUG	
Index: /trunk/Poubelle/archTOI.old/ssthandler.h
===================================================================
--- /trunk/Poubelle/archTOI.old/ssthandler.h	(revision 415)
+++ /trunk/Poubelle/archTOI.old/ssthandler.h	(revision 416)
@@ -24,4 +24,5 @@
 
 //#define SST_DEBUG
+//#define SST_DUMPLOG
 #define NbChanDump (10)
 #define	NbPhotDiodBarette (46)
Index: /trunk/Poubelle/archTOI.old/toiiter.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/toiiter.cc	(revision 415)
+++ /trunk/Poubelle/archTOI.old/toiiter.cc	(revision 416)
@@ -215,4 +215,5 @@
       case boloRaw:
       case boloRawCN:
+      case boloTensCN:
         trigMask |= block_bolo_mask;
         break;
@@ -444,4 +445,5 @@
      if (imes==0 && file->llastBolo()==NULL) return false;
      return file->lastBolo() != NULL;
+   case boloTensCN:
    case boloRaw:
      return file->lastBolo() != NULL;
@@ -533,4 +535,8 @@
    case boloRaw:
      return file->getRawBolo(index, imes);
+   case boloRawCN:
+     return file->getRawBoloCN(index, imes);
+   case boloTensCN:
+     return file->getMuVBoloCN(index, imes);
    case boloGainAmpli:
      return file->getGainAmpli(index);
@@ -613,4 +619,6 @@
        return file->blockNum() == file->getBoloBlockNum();
      case boloRaw:
+     case boloRawCN:
+     case boloTensCN:
        return file->blockNum() == file->getBoloBlockNum();
      case boloGainAmpli:
Index: /trunk/Poubelle/archTOI.old/toiiter.h
===================================================================
--- /trunk/Poubelle/archTOI.old/toiiter.h	(revision 415)
+++ /trunk/Poubelle/archTOI.old/toiiter.h	(revision 416)
@@ -26,4 +26,5 @@
   boloDACI,      // courant (microAmps)
   boloRawCN,     // compression noise on bolo raw
+  boloTensCN,    // compression noise on bolo (microVolts), no filter
   boloTens2T,    // total, microVolts, avec consigne DAC
   boloRes,       // Resistance, ohms
Index: /trunk/Poubelle/archTOI.old/toisvr.cc
===================================================================
--- /trunk/Poubelle/archTOI.old/toisvr.cc	(revision 415)
+++ /trunk/Poubelle/archTOI.old/toisvr.cc	(revision 416)
@@ -8,5 +8,7 @@
 
 TOISvr::TOISvr()
-{}
+{
+  defaultInclude();
+}
 
 // To avoid special copy constructor handling, we will not
@@ -109,4 +111,5 @@
     else tsttoi(boloTens2T)
     else tsttoi(boloRawCN)
+    else tsttoi(boloTensCN)
     else tsttoi(dilDAC)
     else tsttoi(dilSwitch)
@@ -215,2 +218,14 @@
   return true;
 }
+
+void TOISvr::defaultInclude() {
+  processRequest("#REQVERSION V_230999");
+  processRequest("#MJD0 1376.8358818");
+  processRequest("#PERECH 0.005836818076");
+  processRequest("#COMMENT ***WARNING***");
+  processRequest("#COMMENT ***SOME TOI'S ARE PRELIMINARY***");
+  processRequest("#COMMENT gyroSpeed is not calibrated");
+  processRequest("#COMMENT azimut/alpha/delta use galaxy crossings");
+  processRequest("#COMMENT and assume no pendulation");
+  
+}
Index: /trunk/Poubelle/archTOI.old/toisvr.h
===================================================================
--- /trunk/Poubelle/archTOI.old/toisvr.h	(revision 415)
+++ /trunk/Poubelle/archTOI.old/toisvr.h	(revision 416)
@@ -42,4 +42,6 @@
   virtual bool processOption(string keyw, string args);
   
+  void defaultInclude();
+  
 protected:
   TOIIter iter;