Index: /trunk/Poubelle/archTOI.old/Makefile
===================================================================
--- /trunk/Poubelle/archTOI.old/Makefile	(revision 420)
+++ /trunk/Poubelle/archTOI.old/Makefile	(revision 421)
@@ -1,58 +1,82 @@
-CXX=cxx
-CFITSIODIR=../cfitsio
-CPPFLAGS=-O -g -I$(CFITSIODIR)
-#CPPFLAGS=-g -I$(CFITSIODIR)
+ifeq ($(HOSTTYPE), alpha)
+  CXX  = cxx
+endif
+ifndef (CFITSIODIR)
+  CFITSIODIR = ../cfitsio
+endif
+CPPFLAGS    =-O -g -I$(CFITSIODIR)
+
 LDLIBS=-L$(CFITSIODIR) -lcfitsio
+
+default: archtoi
+
+clean:
+	rm -f archtoi *.o archdump
+
+
 archtoi: archtoimain.o archtoi.o archeopsfile.o decompress.o toiiter.o toisvr.o archeops.o \
          ssthandler.o toiinterpolator.o gpsparser.o asigps.o \
          auxinterpgps.o tsid.o archparam.o dyffttools.o fft_mayer.o \
          formepulse.o pisteetoile.o sstetoile.o transfelec.o \
-	 gyrohandler.o
+	 gyrohandler.o aa_hadec.o templocator.o
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm 
 archdump: archtoidump.o archeopsfile.o decompress.o archeops.o ssthandler.o
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm
 
+aa_hadec.o: aa_hadec.c aa_hadec.h
+archeops.o: archeops.c archeops_28.c archeops.h archeops_28.h
+archeops_24.o: archeops_24.c archeops.h archeops_28.h
+archeops_25.o: archeops_25.c archeops.h archeops_28.h
+archeops_26.o: archeops_26.c archeops.h archeops_28.h
+archeops_27.o: archeops_27.c archeops.h archeops_28.h
+archeops_28.o: archeops_28.c archeops.h archeops_28.h
+decompress.o: decompress.c archeops.h archeops_28.h compress.h
+opendir.o: opendir.c dirent.h
 archeopsfile.o: archeopsfile.cc archeopsfile.h archeops.h \
- archeops_28.h ssthandler.h gpsparser.h compress.h
-#	cxx  -O -g -I../cfitsio  -c archeopsfile.cc -o archeopsfile.o -assume noaligned_objects
+ archeops_28.h ssthandler.h sstetoile.h pisteetoile.h transfelec.h \
+ formepulse.h gpsparser.h gyrohandler.h compress.h
+archparam.o: archparam.cc archparam.h
 archtoi.o: archtoi.cc archeopsfile.h archeops.h archeops_28.h \
- ssthandler.h gpsparser.h toisvr.h toiiter.h auxgps.h tsid.h archtoi.h \
- $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h asigps.h auxinterpgps.h
+ ssthandler.h sstetoile.h pisteetoile.h transfelec.h formepulse.h \
+ gpsparser.h toisvr.h toiiter.h auxgps.h tsid.h archtoi.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h archparam.h archvers.h
 archtoidump.o: archtoidump.cc archeopsfile.h archeops.h archeops_28.h \
- ssthandler.h gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
- $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h
+ ssthandler.h sstetoile.h pisteetoile.h transfelec.h formepulse.h \
+ gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h
 archtoimain.o: archtoimain.cc archeopsfile.h archeops.h archeops_28.h \
- ssthandler.h gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
- $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h
+ ssthandler.h sstetoile.h pisteetoile.h transfelec.h formepulse.h \
+ gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h
 asigps.o: asigps.cc asigps.h auxinterpgps.h auxgps.h
 auxinterpgps.o: auxinterpgps.cc auxinterpgps.h auxgps.h \
- $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h archtoi.h toisvr.h toiiter.h \
- archeopsfile.h archeops.h archeops_28.h ssthandler.h gpsparser.h \
- tsid.h
-gpsparser.o: gpsparser.cc gpsparser.h archeops.h archeops_28.h
-test.o: test.cc archeopsfile.h archeops.h archeops_28.h ssthandler.h \
- gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
- $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h
-toiinterpolator.o: toiinterpolator.cc toiinterpolator.h
-toiiter.o: toiiter.cc toiiter.h archeopsfile.h archeops.h \
- archeops_28.h ssthandler.h gpsparser.h auxgps.h tsid.h \
- toiinterpolator.h
-toisvr.o: toisvr.cc toisvr.h toiiter.h archeopsfile.h archeops.h \
- archeops_28.h ssthandler.h gpsparser.h auxgps.h tsid.h
-tsid.o: tsid.cc tsid.h
-archeops.o: archeops.c archeops_28.c archeops.h archeops_28.h
-decompress.o: decompress.c archeops.h archeops_28.h compress.h
-transfelec.o: transfelec.cc transfelec.h
-sstetoile.o: sstetoile.cc sstetoile.h
-ssthandler.o: ssthandler.cc ssthandler.h archeops.h archeops_28.h \
- sstetoile.h pisteetoile.h transfelec.h formepulse.h
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h archvers.h
+dyffttools.o: dyffttools.cc dyffttools.h
+fft_mayer.o: fft_mayer.cc mayer_fft.h trigtbl.h
 formepulse.o: formepulse.cc mayer_fft.h dyffttools.h transfelec.h \
  formepulse.h ssthardware.h
+gpsparser.o: gpsparser.cc gpsparser.h archeops.h archeops_28.h
+gyrohandler.o: gyrohandler.cc gyrohandler.h archeops.h archeops_28.h
 pisteetoile.o: pisteetoile.cc \
  /home/usr203/mnt/gnu/OSF1/lib/gcc-lib/alphaev5-dec-osf4.0d/2.8.1/include/math.h \
  /home/usr203/mnt/gnu/include/g++/iostream.h archparam.h pisteetoile.h \
  sstetoile.h transfelec.h formepulse.h
-dyffttools.o: dyffttools.cc dyffttools.h
-fft_mayer.o: fft_mayer.cc mayer_fft.h trigtbl.h
-archparam.o: archparam.cc archparam.h
-gyrohandler.o: gyrohandler.cc gyrohandler.h archeops.h archeops_28.h
+sstetoile.o: sstetoile.cc sstetoile.h
+ssthandler.o: ssthandler.cc ssthandler.h archeops.h archeops_28.h \
+ sstetoile.h pisteetoile.h transfelec.h formepulse.h
+templocator.o: templocator.cc templocator.h aa_hadec.h
+test.o: test.cc archeopsfile.h archeops.h archeops_28.h ssthandler.h \
+ sstetoile.h pisteetoile.h transfelec.h formepulse.h gpsparser.h \
+ archtoi.h toisvr.h toiiter.h auxgps.h tsid.h ../cfitsio/fitsio.h \
+ ../cfitsio/longnam.h
+toiinterpolator.o: toiinterpolator.cc toiinterpolator.h
+toiiter.o: toiiter.cc archeops.h archeops_28.h toiiter.h \
+ archeopsfile.h ssthandler.h sstetoile.h pisteetoile.h transfelec.h \
+ formepulse.h gpsparser.h auxgps.h tsid.h toiinterpolator.h \
+ archparam.h templocator.h
+toisvr.o: toisvr.cc toisvr.h toiiter.h archeopsfile.h archeops.h \
+ archeops_28.h ssthandler.h sstetoile.h pisteetoile.h transfelec.h \
+ formepulse.h gpsparser.h auxgps.h tsid.h archparam.h asigps.h \
+ auxinterpgps.h
+transfelec.o: transfelec.cc transfelec.h
+tsid.o: tsid.cc tsid.h